# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from fetch_auto_dock_msgs/DockGoal.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class DockGoal(genpy.Message):
  _md5sum = "3802143c05afa4995a977654bae73c88"
  _type = "fetch_auto_dock_msgs/DockGoal"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Inital pose of the dock, usually map referenced
# If the header is empty, or quaternion = (0 0 0 0), then
#   the intial dock pose will be straight ahead of the robot
geometry_msgs/PoseStamped dock_pose

# Specify an (optional) name for the dock
string dock_id

# We can optionally request that the docking node call on the
# navigation stack to get near the dock if we are too far away
bool use_move_base

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['dock_pose','dock_id','use_move_base']
  _slot_types = ['geometry_msgs/PoseStamped','string','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       dock_pose,dock_id,use_move_base

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DockGoal, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.dock_pose is None:
        self.dock_pose = geometry_msgs.msg.PoseStamped()
      if self.dock_id is None:
        self.dock_id = ''
      if self.use_move_base is None:
        self.use_move_base = False
    else:
      self.dock_pose = geometry_msgs.msg.PoseStamped()
      self.dock_id = ''
      self.use_move_base = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.dock_pose.header.seq, _x.dock_pose.header.stamp.secs, _x.dock_pose.header.stamp.nsecs))
      _x = self.dock_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.dock_pose.pose.position.x, _x.dock_pose.pose.position.y, _x.dock_pose.pose.position.z, _x.dock_pose.pose.orientation.x, _x.dock_pose.pose.orientation.y, _x.dock_pose.pose.orientation.z, _x.dock_pose.pose.orientation.w))
      _x = self.dock_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.use_move_base
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.dock_pose is None:
        self.dock_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.dock_pose.header.seq, _x.dock_pose.header.stamp.secs, _x.dock_pose.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dock_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dock_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.dock_pose.pose.position.x, _x.dock_pose.pose.position.y, _x.dock_pose.pose.position.z, _x.dock_pose.pose.orientation.x, _x.dock_pose.pose.orientation.y, _x.dock_pose.pose.orientation.z, _x.dock_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dock_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dock_id = str[start:end]
      start = end
      end += 1
      (self.use_move_base,) = _get_struct_B().unpack(str[start:end])
      self.use_move_base = bool(self.use_move_base)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.dock_pose.header.seq, _x.dock_pose.header.stamp.secs, _x.dock_pose.header.stamp.nsecs))
      _x = self.dock_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.dock_pose.pose.position.x, _x.dock_pose.pose.position.y, _x.dock_pose.pose.position.z, _x.dock_pose.pose.orientation.x, _x.dock_pose.pose.orientation.y, _x.dock_pose.pose.orientation.z, _x.dock_pose.pose.orientation.w))
      _x = self.dock_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.use_move_base
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.dock_pose is None:
        self.dock_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.dock_pose.header.seq, _x.dock_pose.header.stamp.secs, _x.dock_pose.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dock_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dock_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.dock_pose.pose.position.x, _x.dock_pose.pose.position.y, _x.dock_pose.pose.position.z, _x.dock_pose.pose.orientation.x, _x.dock_pose.pose.orientation.y, _x.dock_pose.pose.orientation.z, _x.dock_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dock_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dock_id = str[start:end]
      start = end
      end += 1
      (self.use_move_base,) = _get_struct_B().unpack(str[start:end])
      self.use_move_base = bool(self.use_move_base)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
